package org.processmining.streambasedeventfilter.parameters;

public class ConditionalProbabilitiesBasedXSEventFilterParametersImpl extends XSEventFilterParametersImpl {

	public enum Abstraction {
		SEQUENCE, MULTISET, SET;
	}

	public enum AdjustmentMethod {
		NONE, MAX, MAX_NZ_AVG;
	}

	public enum FilteringMethod {
		BACKWARD, FORWARD, BOTH_DIRECTIONS, ANY;
	}
	
	public enum VotingSystem {
		ANY, MAJORITY_VOTE;
	}

	private int maxPatternLength = 3;
	private FilteringMethod filtermethod = FilteringMethod.BOTH_DIRECTIONS;
	private AdjustmentMethod adjustmentmethod = AdjustmentMethod.MAX_NZ_AVG;
	private Abstraction abstraction = Abstraction.MULTISET;
	private VotingSystem votingSystem = VotingSystem.ANY;
	
	private boolean considerNoiseInAutomaton = false;

	private double cutoffThreshold = 0.01;

	public Abstraction getAbstraction() {
		return abstraction;
	}

	public AdjustmentMethod getAdjustmentmethod() {
		return adjustmentmethod;
	}

	public double getCutoffThreshold() {
		return cutoffThreshold;
	}

	public FilteringMethod getFiltermethod() {
		return filtermethod;
	}

	public int getMaxPatternLength() {
		return maxPatternLength;
	}

	public VotingSystem getVotingSystem() {
		return votingSystem;
	}

	public boolean isConsiderNoiseInAutomaton() {
		return considerNoiseInAutomaton;
	}

	public void setAbstraction(Abstraction abstraction) {
		this.abstraction = abstraction;
	}

	public void setAdjustmentmethod(AdjustmentMethod adjustmentmethod) {
		this.adjustmentmethod = adjustmentmethod;
	}

	public void setConsiderNoiseInAutomaton(boolean considerNoiseInAutomaton) {
		this.considerNoiseInAutomaton = considerNoiseInAutomaton;
	}

	public void setCutoffThreshold(double cutoffThreshold) {
		this.cutoffThreshold = cutoffThreshold;
	}

	public void setFiltermethod(FilteringMethod filtermethod) {
		this.filtermethod = filtermethod;
	}

	public void setMaxPatternLength(int maxPatternLength) {
		this.maxPatternLength = maxPatternLength;
	}

	public void setVotingSystem(VotingSystem votingSystem) {
		this.votingSystem = votingSystem;
	}

}
